"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var v4_1 = __importDefault(require("uuid/v4"));
/**
 * Returns a database name string.
 * @param {string} dbName
 */
function generateDbName(dbName) {
    return dbName || v4_1.default();
}
exports.generateDbName = generateDbName;
/**
 * Extracts the host and port information from a mongodb URI string.
 * @param {string} uri mongodb URI
 */
function getHost(uri) {
    return uri.replace('mongodb://', '').replace(/\/.*/, '');
}
exports.getHost = getHost;
exports.default = generateDbName;
//# sourceMappingURL=db_util.js.map